#include "CircularListNode.h"

CircularList* createCircularList()
{
	CircularList* pReturn = NULL;
	
	pReturn = (CircularList*)malloc( sizeof(CircularList) );
	
	if( pReturn != NULL )
	{
		memset(pReturn, 0, sizeof(CircularList));
	}
	else
	{
		printf("createCircularList() Error! CircularList Ҵ \n");
	}
	
	
	return pReturn;
}

int addCLElement(CircularList* pList, int position, CircularListNode element)
{
	int i = 0;
	int ret = FALSE;
	
	CircularListNode *pNewNode = NULL;
	CircularListNode *pPreNode = NULL;
	CircularListNode *pLastNode = NULL;
	
	if( pList != NULL )
	{
		if(position >= 0 && position <= pList->curElementCnt)
		{
			//pNewNode Ҵ
			pNewNode = (CircularListNode*)malloc(sizeof(CircularListNode));
			if(pNewNode == NULL)
			{
				printf("addCLElement Error! pNewNode Ҵ  \n");
				
				return ret;
			}
			*pNewNode = element;
			pNewNode->pLink = NULL;
			
			if( position == 0 )
			{
				//if( pList->pLink == NULL )
				if( pList->curElementCnt == 0 )
				{
					pList->pLink = pNewNode;
					pNewNode->pLink = pNewNode;
				}
				else
				{
					pLastNode = pList->pLink;	//Ȯ
					
					while(pLastNode->pLink != pList->pLink)
					{
						pLastNode = pLastNode->pLink;
					}
					
					pNewNode->pLink = pList->pLink;
					pList->pLink = pNewNode;
					pLastNode->pLink = pNewNode;
				}
			}
			else
			{
				//pPreNode ã
				pPreNode = pList->pLink;
				for(i=0; i<position-1; i++)
				{
					pPreNode = pPreNode->pLink;
				}
				
				pNewNode->pLink = pPreNode->pLink;
				pPreNode->pLink = pNewNode;
			}
			
			ret = TRUE;
			pList->curElementCnt++;
		}
		else
		{
			printf("addCLElement Error! 0<=position(%d)<=curElementCnt ƴ\n", position);
		}
	}
	
	return ret;
}

int removeCLElement(CircularList* pList, int position)
{
	int i = 0;
	int ret = FALSE;
	CircularListNode* pLastNode = NULL;
	CircularListNode* pPreNode = NULL;
	CircularListNode* pDelNode = NULL;
	
	if(pList != NULL)
	{
		if( position >= 0 && position < pList->curElementCnt )
		{
			if( pList->curElementCnt != 0 )
			{
				if( position == 0 )
				{
					pDelNode = pList->pLink;

					if( pList->curElementCnt == 1 )
					{
						free(pDelNode);
						pList->pLink = NULL;
					}
					else
					{
						pLastNode = pList->pLink;
						while(pLastNode->pLink != pList->pLink)
						{
							pLastNode = pLastNode->pLink;
						}
						
						pDelNode = pLastNode->pLink;
						
						pList->pLink = pDelNode->pLink;
						pLastNode->pLink = pDelNode->pLink;
						free(pDelNode);
					}
				}
				else
				{
					pPreNode = pList->pLink;
					for(i=0; i<position-1; i++)
					{
						pPreNode = pPreNode->pLink;
					}
					
					pDelNode = pPreNode->pLink;
					
					pPreNode->pLink = pDelNode->pLink;
					free(pDelNode);
				}
				
				pList->curElementCnt--;
				ret = TRUE;
			}
			else
			{
				printf("removeCLElement Error! 尡 .  尡 0 \n");
			}
		}
		else
		{
			printf("removeCLElement Error! 0<=position(%d)<curElementCnt ƴ\n", position);
		}
	}
	else
	{
		printf("pList NULL\n");
	}
	
	return ret;
}

CircularListNode* getCLElement(CircularList* pList, int position)
{
	int i;

	CircularListNode* pReturn = NULL;
	
	if(pList != NULL)
	{
		if( position >= 0 && position < pList->curElementCnt )
		{
			pReturn = pList->pLink;

			for(i=0; i<position; i++)
			{
				pReturn = pReturn->pLink;
			}
		}
		else
		{
			printf("getCLElement Error! 0<=position(%d)<pList->curElementCnt ƴ!!", position);
		}
	}
	
	return pReturn;
}

void displayCircularList(CircularList* pList)
{
	int i = 0;
	
	if(pList != NULL)
	{
		printf("   : %d \n", pList->curElementCnt);
		
		for(i=0; i<pList->curElementCnt; i++)
		{
			printf("[%d] : %d \n", i, getCLElement(pList, i)->data);
		}
	}
}

int getCircularListLength(CircularList* pList)
{
	int ret = 0;
	
	if(pList != NULL)
	{
		ret = pList->curElementCnt;
	}

	return ret;
}

void deleteCircularList(CircularList* pList)
{
	if(pList != NULL)
	{
		clearCircularList(pList);
		free(pList);
	}
}

void clearCircularList(CircularList* pList)
{
	if(pList != NULL)
	{
		while(pList->curElementCnt > 0)
		{
			removeCLElement(pList, 0);
		}
	}
}
